'''
Created on Apr 7, 2010

@author: thebwt
'''
import os
import math

from pyglet.graphics import vertex_list, Batch
import pyglet.resource
from pyglet.sprite import Sprite

class GameLayer(Batch):
	def __init__(self):
		super(GameLayer, self).__init__()

class GameMap(GameLayer):
	def __init__(self):
		super(GameMap, self).__init__()
		self.hexImg = pyglet.resource.image('hex.png')
		self.hexOverImg = pyglet.resource.image('hex-over.png')
		self.over = Sprite(self.hexOverImg)
		#draw map
		self.w,self.h = 10,10
		self.tiles = [ [None]*self.w for i in range(self.h) ]
		for i in range(self.w):
			for j in range(self.h):
				if j%2 != 0:
					k = 44.5
				else:
					k = 0
				self.tiles[j][i]=(Sprite(self.hexImg, batch=self, y=(i*89)+k, x=j*77))
				
	def posToTile(self, inx,iny):
		y1= (iny-44.5)/89.0
		y2= (iny)/89.0
		x=(inx)/77.0
		x= int(x)
		if x%2:
			y=int(y1)
		else:
			y=int(y2)
		modx=inx-(x*77)
		mody=iny-(y*89)
		if x%2: mody -= 44.5
		if ((modx<25) and (mody<44)):
			if mody < (modx*(-45.5/(25+(1/3))))+45.5:
				if x%2:
					x-=1
				else:
					x-=1
					y-=1
		elif (modx<25) and (mody>44):
			if mody > (modx*(45.5/(25+(1/3))))+45.5:
				if x%2:
					x-=1
					y+=1
				else:
					x-=1
		return x, y
		
	def overTile(self,x,y):
		x,y=self.posToTile(x,y)
		if ((x>-1) and (y>-1)) and ((x<self.w) and (y<self.h)):
			if self.over.position != self.tiles[x][y].position:
				self.over.position = self.tiles[x][y].position

class GameGui(GameLayer):
	def __init__(self):
		pass

class GameAction(GameLayer):
	def __init__(self):
		pass
