'''
Created on Apr 2, 2010

@author: thebwt
'''
from pyglet.text import Label
from pyglet.graphics import Batch

class Button(Label):
	'''
	classdocs
	'''


	def __init__(self, wad, batch = None):
		'''
		Constructor
		'''
		super(Button, self).__init__(wad[0], color=(0,0,0,255), batch = batch, anchor_y = 'top', bold = True)
		self.defaultColor = (0,0,0,255)
		self.overColor = (255,0,0,255)
		if len(wad)>1:
			self.func = wad[1]
		else:
			self.func = self.dud
		
	def dud(self):
		pass

class ButtonList(Batch):
	'''
	classdocs
	'''
	def __init__(self, pos = None, buttons = []):
		super(ButtonList, self).__init__()
		self.buttons = []
		self.pos = self.x, self.y = pos
		
		#Set up the buttons
		y = self.y
		for button in buttons:
			newbutton = Button(button, batch = self)
			newbutton.x = self.x
			newbutton.y = y
			self.buttons.append(newbutton)
			y -= newbutton.content_height

	def posToButton(self, x, y):
		for button in self.buttons:
			if (button.x < x < button.x + button.content_width)and(button.y > y >button.y - button.content_height):
				return button

class DirtyButtonList(Batch):
	'''
	classdocs
	'''
	def __init__(self, buttons = []):
		super(DirtyButtonList, self).__init__()
		self.buttons = []
		
		#Set up the buttons
		for button in buttons:
			button.batch = self
			self.buttons.append(button)

	def posToButton(self, x,y):
		for button in self.buttons:
			if (button.x < x < button.x + button.content_width)and(button.y > y >button.y - button.content_height):
				return button
